

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was spheral_cxx-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

if(NOT SPHERAL_FOUND)
  #----------------------------------------------------------------------------
  # Set user configuration options and features
  #----------------------------------------------------------------------------

  # Language features
  set(SPHERAL_ENABLE_MPI "ON")
  set(SPHERAL_ENABLE_OPENMP "ON")
  set(SPHERAL_ENABLE_CUDA "OFF")
  if(NOT axom_DIR)
    set(axom_DIR "/usr/local/lib/cmake" CACHE PATH "")
  endif()

  set(SPHERAL_CXX_INSTALL_PREFIX "/usr/local")
  set(SPHERAL_CXX_INCLUDE_DIRS "${SPHERAL_CXX_INSTALL_PREFIX}/include")
  if(NOT ON AND NOT TARGET Python3)
    set(python_DIR "/usr/local")
    set(Python_EXECUTABLE ${python_DIR}/bin/python3)
    set(Python3_EXECUTABLE ${python_DIR}/bin/python3)
    find_package(Python3 COMPONENTS Interpreter Development)
    set(PYTHON_EXE ${Python3_EXECUTABLE})
  endif()

  if(NOT TARGET axom)
    find_package(axom REQUIRED QUIET NO_DEFAULT_PATH PATHS ${axom_DIR} ${axom_DIR}/lib ${axom_DIR}/lib/cmake)
  endif()
  if(SPHERALC_STANDALONE)
    set(CMAKE_C_COMPILER "/usr/local/libexec/ccache/cc" CACHE PATH "Spheral C compiler path")
    set(CMAKE_CXX_COMPILER "/usr/local/libexec/ccache/c++" CACHE PATH "Spheral C++ compiler path")
    set(CMAKE_Fortran_COMPILER "/usr/local/bin/gfortran13" CACHE PATH "Spheral C++ compiler path")
    set(ENABLE_MPI ON CACHE BOOL "")
    if(SPHERAL_ENABLE_MPI)
      set(MPI_C_COMPILER "/usr/local/bin/mpicc" CACHE PATH "")
      set(MPI_CXX_COMPILER "/usr/local/bin/mpicxx" CACHE PATH "")
      set(MPI_Fortran_COMPILER "/usr/local/bin/mpif90" CACHE PATH "")
    endif()
  endif()
  include("${SPHERAL_CXX_INSTALL_PREFIX}/lib/cmake/spheral_cxx-targets.cmake")

  set_property(TARGET Spheral_CXX
    APPEND PROPERTY
    INTERFACE_INCLUDE_DIRECTORIES ${SPHERAL_CXX_INCLUDE_DIRS})
  set(SPHERAL_FOUND TRUE)
endif()
